<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to insert in tree in level order</p>
		<button onclick="level_order()">Level order</button>
		<p id="demo"></p>

		<script>
			function level_order() {
                // Queue class 
				class Queue 
				{ 
					// Array is used to implement a Queue 
					constructor() 
					{ 
						this.items = []; 
					} 
								  
					// enqueue function 
					enqueue(element) 
					{     
						// adding element to the queue 
						this.items.push(element); 
					}
					
					// dequeue function 
					dequeue() 
					{ 
						// removing element from the queue returns underflow when called  on empty queue 
						if(this.isEmpty()) 
							return "Underflow"; 
						return this.items.shift(); 
					} 
					
					
					// front function 
					front() 
					{ 
						// returns the Front element of  
						// the queue without removing it. 
						if(this.isEmpty()) 
							return "No elements in Queue"; 
						return this.items[0]; 
					} 

                    // isEmpty function 
					isEmpty() 
					{ 
						// return true if the queue is empty. 
						return this.items.length == 0; 
					}
					
				}
				// Node class
				class Node {
					constructor(data)
					{
						this.data = data;
						this.left = null;
						this.right = null;
					}
				}
				
				// Binary Search tree class
				class Tree {
					constructor() {
					// root of a binary seach tree
					this.root = null;
				}

                //function to insert element in binary tree according to level order 
                insert(key) { 
                    var q = new Queue(); 
                    q.enqueue(this.head); 
                    // Do level order traversal until we find an empty place.  
                     while (!q.isEmpty()) { 
                        var temp = q.front(); 
                        q.dequeue(); 
                        if (temp.left == null) { 
                            temp.left = new Node(key); 
                            break; 
                        } 
                        else
                            q.enqueue(temp.left); 
                        if (temp.right == null) { 
                            temp.right = new Node(key); 
                            break; 
                        } 
                        else
                            q.enqueue(temp.right); 
                    }
                    console.log(key+" inserted"); 
                } 
				
				
				inorder(node) {
					if(node !== null) {
					this.inorder(node.left);
					console.log(node.data);
					this.inorder(node.right);
					}
				}
			
				
			// returns root of the tree
			getRootNode() {
				return this.root;
			}
			
		}

            // create an object for the BinarySearchTree
            var tree = new Tree();
            // Inserting nodes to the BinarySearchTree
            tree.root = new Node(4);
            tree.insert(3);
            tree.insert(4);
            tree.insert(5);
            tree.insert(6);
            tree.insert(7);
            tree.insert(8);
            var root = tree.getRootNode();
            console.log(root.data);
            tree.inorder(root);
		}
		</script>

	</body>
</html>